/*
 * PrimaryDef.java
 *
 * Created on 22  2002 ., 16:15
 */

package com.fn.dbgen;


import java.util.Map;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class PrimaryDef {
    
    private String beforeTable;
    private String tableDef;
    private String afterTable;
    private boolean quotes;
    
    /** Creates a new instance of PrimaryDef */
    public PrimaryDef(Element element) throws DgException {
        quotes = XMLUtils.getTagAttrib(element, "quotes", true);
        beforeTable = XMLUtils.getTrimmedSubtagData(element, "beforetable");
        tableDef = XMLUtils.getTrimmedSubtagData(element, "tabledef");
        afterTable = XMLUtils.getTrimmedSubtagData(element, "aftertable");
    }
    
    public void generateField(Element field, Table table) throws DgException {
        String fields = quotes ? Macros.processFieldList(XMLUtils.getTrimmedData(field)) :
                    XMLUtils.getTrimmedData(field);
        Map args = table.getParams();
        args.put("f", fields);
        if ((tableDef != null) && (tableDef.length() > 0))
            table.addDef(Macros.processMacroses(tableDef, field, args));
        if ((beforeTable != null) && (beforeTable.length() > 0))
            table.addBefore(Macros.processMacroses(beforeTable, field, args));
        if ((afterTable != null) && (afterTable.length() > 0))
            table.addAfter(Macros.processMacroses(afterTable, field, args));
    }
}
