/*
 * Utils.java
 *
 * Created on 28  2002 ., 18:49
 */

package com.fn.dbgen;


import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


/**
 *
 * @author  asso
 */
public class XMLUtils {

    public static boolean isBlankText(String str) {
        String s = str.trim();
        if (s.length() == 0)
            return true;
        else
            return false;
    }            

    /*  31 */
    public static String getTrimmedData(Element element) throws DgException {
        StringBuffer sb = new StringBuffer();
        NodeList nodeList = element.getChildNodes();
        int len = nodeList.getLength();
        for (int i = 0; i < len; i++) {
            Node node = nodeList.item(i);
            switch (node.getNodeType()) {
                case Node.ATTRIBUTE_NODE:
                case Node.COMMENT_NODE:
                    break;
                case Node.CDATA_SECTION_NODE:
                case Node.TEXT_NODE:
                    sb.append(node.getNodeValue().trim());
                    break;
                default:
                    throw new DgException("Invalid data section");
            }
        }
        return sb.toString();
    }
    
    public static int getTagAttrib(Element element, String attrib, int dflt) {
        String sv = element.getAttribute(attrib);
        int v = dflt;
        if (! sv.equals(""))
            try {
                v = Integer.parseInt(sv);
            } catch (Exception e) { }
        return v;
    }
    
    public static boolean getTagAttrib(Element element, String attrib, boolean dflt) {
        String sv = element.getAttribute(attrib);
        boolean v = dflt;
        if (! sv.equals("")) {
            if (sv.equalsIgnoreCase("yes") || sv.equalsIgnoreCase("on") || 
                    sv.equals("1") || sv.equalsIgnoreCase("true"))
                v = true;
            else
                if (sv.equalsIgnoreCase("no") || sv.equalsIgnoreCase("off") || 
                        sv.equals("0") || sv.equalsIgnoreCase("false"))
                    v = false;
        }
        return v;
    }
    
    public static Element getSubtag(Element element, String name) throws DgException {
        NodeList nodeList = element.getElementsByTagName(name);
        if (nodeList.getLength() < 0)
            return null;
        if (nodeList.getLength() > 1)
            throw new DgException("More than one subtag this name '" + name + "'");
        return (Element)nodeList.item(0);
    }
    
    public static String getTrimmedSubtagData(Element element, String subtag) throws DgException {
        Element st = getSubtag(element, subtag);
        if (st == null)
            return "";
        else
            return getTrimmedData(st);
    }
}
